# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Formulardatenparser
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
sub formparser {

if ($ENV{'REQUEST_METHOD'} eq "GET") { 
$input = $ENV{'QUERY_STRING'};
} elsif($ENV{'REQUEST_METHOD'} eq "POST") {
read(STDIN,$input,$ENV{'CONTENT_LENGTH'});
}

@pairs = split(/&/, $input);
foreach $pair (@pairs) {

($name, $value) = split(/=/, $pair);
$name =~ tr/+/ /;
$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ s/\r//g;
$value =~ s/\+/&#43;/g;
$value =~ s/\|//g;

$FORM{$name} = $value;
}

}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Dateisperre anlegen und loeschen/ Sub Sperrdatei anlegen
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
sub sperrdatei {  

my ($sperrdatei) = @_;
my $wert = 1;
my $warten = 0;

while($wert and $warten < 20) {
$wert = ist_sperreaktiv($sperrdatei);
$warten++;
}
unlink($sperrdatei) if ($warten == 20);
open(SPERRDATEI, ">$sperrdatei");    
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Sub Sperrdateiloeschung
# Existiert eine Sperrdatei wird diese geloescht  
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
sub entsperren {
my ($sperrdatei) = @_;
close(SPERRDATEI);
unlink($sperrdatei) if (-e $sperrdatei);
}
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Sub Sperrdateipruefung
# Hier wirf geprueft ob eine Sperrdatei existiert, wenn ja, Wartezeit 3 
# Sekunden und Rueckgabewert 1, ansonsten 0
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
sub ist_sperreaktiv {
my ($datei) = shift;
if (-e $datei) {
sleep (3);
return 1;
} else {
return 0;
}
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Scriptfehlerausgabe
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
sub scripterror {

my($fehlermitteilung) = @_;

$fa .= sprintf "Fehlermeldung: %s Es ist ein fataler Scriptfehler in Zeile %d aufgetreten.", $fehlermitteilung, (caller)[2];

print qq~
<html>
<head>
<title>Fehlermeldung aufgetreten</title>
</head>
<body bgcolor="#FFFFFF">
<font face="verdana" size="5"><b>SCRIPT FEHLER FESTGESTELLT!!!</b></font>
<hr>
<font face="verdana" size="2">$fa
<hr>
</font>
</body>
</html>
~;
exit;       
}



# - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Datumsroutine
# - - - - - - - - - - - - - - - - - - - - - - - - - - #
sub datumsausgabe {

@tagekurz = ('So','Mo','Di','Mi','Do','Fr','Sa');
@monatekurz = ('Jan.','Feb.','Maerz','Apr.','Mai.','Jun.','Jul.','Aug.','Sept.','Okt.','Nov.','Dez.');
@tage = ('Sonntag','Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag');
@monate = ('Januar','Februar','Maerz','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember');
($sec, $min, $stunde, $mtag, $mon, $jahr, $tag, $nr_tag, $isdst) = localtime(time);
$monat = $mon+1;
if($monat < 10) { $monat = "0$monat"; }
if($stunde < 10) { $stunde = "0$stunde"; }
if ($min < 10) { $min = "0$min"; }
if ($sec < 10) { $sec = "0$sec"; }
$jahr = 1900 + $jahr;

# Ausgabe z.B. 17:39:43 Uhr Sonntag, 14. Juli , 2002
$datumlang = "$stunde:$min:$sec Uhr am $tage[$tag], den $mtag. $monate[$mon] , $jahr";

# Alle Datumswerte, Ausgabe z.B. Sonntag, 14. Juli, 2002
$datum = "$tage[$tag], $mtag. $monate[$mon], $jahr";

# Ausgabe Monate in Kurzform, z.B. Sonntag, 14. Jul. 2002
$datumkurz = "$tage[$tag], $mtag. $monatekurz[$mon] $jahr";

# Ausgabe Tag + Monate in Kurzform, z.B. So, 14. Jul.  2002 
$datumkurz_tag_mon = "$tagekurz[$tag], $mtag. $monatekurz[$mon] $jahr";

# Ausgabe Tag + Monate in Kurzform, z.B. 14. 07. 2002 
$datum_tag_mon = "$mtag.$monat.$jahr";

# Ausgabe Tag + Monate in Kurzform, z.B. 14. 07. 2002 
$datum_backup = "$mtag-$monat-$jahr-$stunde:$min:$sec";

# Ausgabe der Zeit in Sek. seit 1970
$zeit = time();
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Letzte Zeile nicht aendern/entfernen
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #

1;

